// Auto-generated. Do not edit!

// (in-package kobuki_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;

//-----------------------------------------------------------

class PowerSystemEvent {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.event = null;
    }
    else {
      if (initObj.hasOwnProperty('event')) {
        this.event = initObj.event
      }
      else {
        this.event = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type PowerSystemEvent
    // Serialize message field [event]
    bufferOffset = _serializer.uint8(obj.event, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type PowerSystemEvent
    let len;
    let data = new PowerSystemEvent(null);
    // Deserialize message field [event]
    data.event = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    return 1;
  }

  static datatype() {
    // Returns string type for a message object
    return 'kobuki_msgs/PowerSystemEvent';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'f6464657d6c911b00c7bc7b43a154bf8';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Power system events
    # This message is generated by important changes in the power system:
    #  - plug/unplug to the docking base or adapter
    #  - transitions to low/critical battery levels
    #  - battery charge completed
    
    uint8 UNPLUGGED           = 0
    uint8 PLUGGED_TO_ADAPTER  = 1
    uint8 PLUGGED_TO_DOCKBASE = 2
    uint8 CHARGE_COMPLETED    = 3
    uint8 BATTERY_LOW         = 4
    uint8 BATTERY_CRITICAL    = 5
    
    uint8 event
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new PowerSystemEvent(null);
    if (msg.event !== undefined) {
      resolved.event = msg.event;
    }
    else {
      resolved.event = 0
    }

    return resolved;
    }
};

// Constants for message
PowerSystemEvent.Constants = {
  UNPLUGGED: 0,
  PLUGGED_TO_ADAPTER: 1,
  PLUGGED_TO_DOCKBASE: 2,
  CHARGE_COMPLETED: 3,
  BATTERY_LOW: 4,
  BATTERY_CRITICAL: 5,
}

module.exports = PowerSystemEvent;
